//+------------------------------------------------------------------+
//|                                               DoublecciWoody.mq4 |
//|
//+------------------------------------------------------------------+
#property copyright "DoublecciWoody."
#property link      "DoublecciWoody"

#property indicator_separate_window
#property indicator_buffers    6
#property indicator_color1     Red   
#property indicator_color2     Red  
#property indicator_color3     Blue
#property indicator_color4     Blue
#property indicator_color5     Chartreuse 
#property indicator_color6     Aqua  
#property indicator_levelcolor White
#property indicator_width1     20
#property indicator_width2     20
#property indicator_width3     20
#property indicator_width4     20
#property indicator_width5     1
#property indicator_width6     1
//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern double    TrendCCI_Period = 12.5;
extern double    EntryCCI_Period = 4.6875;
extern int    LineSize1       = 20;
extern int    LineSize2       = 1;
extern int    LineSize3       = 1;
extern double levelOb3        = 50;
extern double levelOb2        = 50;
extern double levelOb1        = 50;
extern double levelOs1        = -50;
extern double levelOs2        = -50;
extern double levelOs3        = -50;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;

//
//
//
//
//

double TCCI[];
double ECCI[];
double Upa[];
double Upb[];
double Dna[];
double Dnb[];
double trend[];
double trens[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;
string shortName;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
//
//

int init()  
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,Dna);   SetIndexStyle(0,DRAW_HISTOGRAM,0,LineSize1);
   SetIndexBuffer(1,Dnb);   SetIndexStyle(1,DRAW_HISTOGRAM,0,LineSize2);
   SetIndexBuffer(2,Upa);   SetIndexStyle(2,DRAW_HISTOGRAM,0,LineSize1);
   SetIndexBuffer(3,Upb);   SetIndexStyle(3,DRAW_HISTOGRAM,0,LineSize2);
   SetIndexBuffer(4,TCCI);  SetIndexStyle(4,DRAW_LINE,STYLE_SOLID,LineSize3); SetIndexLabel(4, "TrendCCI");
   SetIndexBuffer(5,ECCI);  SetIndexStyle(5,DRAW_LINE,STYLE_SOLID,LineSize3); SetIndexLabel(5, "EntryCCI");
   SetIndexBuffer(6,trend);
   SetIndexBuffer(7,trens);
   
   SetLevelValue(0,levelOb3);
   SetLevelValue(1,levelOb2);
   SetLevelValue(2,levelOb1);
   SetLevelValue(3,0);
   SetLevelValue(4,levelOs1);
   SetLevelValue(5,levelOs2);
   SetLevelValue(6,levelOs3);
   
     //
     //
     //
     //
     //
     
        indicatorFileName = WindowExpertName();
        calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
        returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
        timeFrame         = stringToTimeFrame(TimeFrame); 
     
     //
     //
     //
     //
     //

   IndicatorShortName(timeFrameToString(timeFrame)+" RP ("+DoubleToStr(TrendCCI_Period,2)+","+DoubleToStr(EntryCCI_Period,2)+")");
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
//
//

int deinit()  {   return(0);  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars)  { Dna[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
     for(int i=limit; i>=0; i--)
     { 
   
      TCCI[i] = iCCI(NULL,0,TrendCCI_Period,PRICE_TYPICAL,i);
      ECCI[i] = iCCI(NULL,0,EntryCCI_Period,PRICE_TYPICAL,i);
      
      //
      //
      //
      //
      //
      
      Dna[i]   = EMPTY_VALUE;
      Dnb[i]   = EMPTY_VALUE;
      Upa[i]   = EMPTY_VALUE;
      Upb[i]   = EMPTY_VALUE;
      trend[i] = trend[i+1];
      trens[i] = trens[i+1];
      
      if (TCCI[i] > 0 && ECCI[i] > 0)                 trend[i] =  1;
      if (TCCI[i] < 0 && ECCI[i] < 0)                 trend[i] = -1;
      if (TCCI[i] > TCCI[i+1] && ECCI[i] > ECCI[i+1]) trens[i] =  1;
      if (TCCI[i] < TCCI[i+1] && ECCI[i] < ECCI[i+1]) trens[i] = -1;
      
      if (trend[i]== 1 && trens[i] == 1) Upa[i] = TCCI[i];
      if (trend[i]== 1 && trens[i] ==-1) Upb[i] = TCCI[i];
      if (trend[i]==-1 && trens[i] ==-1) Dna[i] = TCCI[i];
      if (trend[i]==-1 && trens[i] == 1) Dnb[i] = TCCI[i];    
               
   }
   
   manageAlerts();
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
             
         for(i=limit; i>=0; i--)
         {
         
            int y = iBarShift(NULL,timeFrame,Time[i]);
               TCCI[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TrendCCI_Period,EntryCCI_Period,4,y);
               ECCI[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TrendCCI_Period,EntryCCI_Period,5,y);
               trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TrendCCI_Period,EntryCCI_Period,6,y);
               trens[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TrendCCI_Period,EntryCCI_Period,7,y);
               Dna[i]   = EMPTY_VALUE;
               Dnb[i]   = EMPTY_VALUE;
               Upa[i]   = EMPTY_VALUE;
               Upb[i]   = EMPTY_VALUE;
               
               if (TCCI[i] > 0 && ECCI[i] > 0)                 trend[i] =  1;
               if (TCCI[i] < 0 && ECCI[i] < 0)                 trend[i] = -1;
               if (TCCI[i] > TCCI[i+1] && ECCI[i] > ECCI[i+1]) trens[i] =  1;
               if (TCCI[i] < TCCI[i+1] && ECCI[i] < ECCI[i+1]) trens[i] = -1;
      
               if (trend[i]== 1 && trens[i] == 1) Upa[i] = TCCI[i];
               if (trend[i]== 1 && trens[i] ==-1) Upb[i] = TCCI[i];
               if (trend[i]==-1 && trens[i] ==-1) Dna[i] = TCCI[i];
               if (trend[i]==-1 && trens[i] == 1) Dnb[i] = TCCI[i];    
               
        }
   
    manageAlerts();
 return(0);
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,0,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"cross zero up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"cross zero down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," cci ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," cci "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

   
      
      
   
   